# -------------------------------------------------------------------------------- NOTEBOOK-CELL: CODE
# -*- coding: utf-8 -*-
import dataiku
import pandas as pd, numpy as np
from dataiku import pandasutils as pdu

# -------------------------------------------------------------------------------- NOTEBOOK-CELL: CODE
# -*- coding: utf-8 -*-
import dataiku
import pandas as pd, numpy as np
from dataiku import pandasutils as pdu
from imblearn.datasets import make_imbalance
from imblearn.over_sampling import SMOTENC
from collections import Counter

# Read recipe inputs
train_80P_prepared = dataiku.Dataset("Train_80P_prepared")
train_80P_prepared_df = train_80P_prepared.get_dataframe()

# -------------------------------------------------------------------------------- NOTEBOOK-CELL: CODE
X=train_80P_prepared_df.drop(['Punishmentfound'],axis=1)
y=train_80P_prepared_df.Punishmentfound

# -------------------------------------------------------------------------------- NOTEBOOK-CELL: CODE
Counter(y)

# -------------------------------------------------------------------------------- NOTEBOOK-CELL: CODE
# Random undersampling
X_rs, y_rs = make_imbalance(X,y,sampling_strategy={True:263,False:4000}, random_state=42)
print('After undersampling {}'.format(Counter(y_rs)))

# -------------------------------------------------------------------------------- NOTEBOOK-CELL: CODE
train_under_df = pd.concat([X_rs,y_rs], axis=1)

# -------------------------------------------------------------------------------- NOTEBOOK-CELL: CODE
X_over=train_under_df.drop(['Punishmentfound'],axis=1)
y_over=train_under_df.Punishmentfound
sm = SMOTENC(sampling_strategy=0.125,categorical_features=[2, 3,4],random_state=42, k_neighbors=3)

# -------------------------------------------------------------------------------- NOTEBOOK-CELL: CODE
X_res, y_res = sm.fit_resample(X_over, y_over)

# -------------------------------------------------------------------------------- NOTEBOOK-CELL: CODE
print('Resampled dataset samples per class {}'.format(Counter(y_res)))

# -------------------------------------------------------------------------------- NOTEBOOK-CELL: CODE
train_80P_SMOTENC_df=pd.concat([X_res,y_res], axis=1)

# -------------------------------------------------------------------------------- NOTEBOOK-CELL: CODE
# Write recipe outputs
train_80P_SMOTENC = dataiku.Dataset("Train_80P_SMOTENC")
train_80P_SMOTENC.write_with_schema(train_80P_SMOTENC_df)